var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/routes.ts
var routes_exports = {};
__export(routes_exports, {
  asOpenAPIPath: () => asOpenAPIPath,
  asOpenAPIPathParams: () => asOpenAPIPathParams,
  getRouteMap: () => getRouteMap,
  getRouteSnippets: () => getRouteSnippets,
  routemapToOpenAPI: () => routemapToOpenAPI
});
module.exports = __toCommonJS(routes_exports);
var import_lodash = __toESM(require("lodash"));
var import_openapi3_ts = require("openapi3-ts");
var import_openapi_snippet = __toESM(require("openapi-snippet"));
var import_path_to_regexp = require("path-to-regexp");
var import_zod_openapi = require("@anatine/zod-openapi");
var import_reflect_metadata = require("reflect-metadata");
var getRouteMap = (controllers) => {
  const routemap = controllers.map((Cnt) => {
    const classKey = Reflect.getOwnMetadataKeys(Cnt.prototype).find((k) => k.toString().match(/Class Metadata/));
    const path = classKey ? Reflect.getOwnMetadata(classKey, Cnt.prototype).basePath : "";
    return {
      [Cnt.name]: {
        path,
        actions: Object.getOwnPropertyNames(Cnt.prototype).filter((p) => p !== "constructor").map((p) => ({
          meta: Reflect.getOwnMetadata(p, Cnt.prototype),
          action: p
        })).filter((desc) => desc.meta).map(({ meta, action }) => {
          var _a;
          return {
            action,
            schema: (_a = meta == null ? void 0 : meta.middlewares) == null ? void 0 : _a.map((m) => {
              var _a2;
              return (_a2 = m.params) == null ? void 0 : _a2.schema;
            }).find((s) => s),
            routes: meta.httpRoutes.map((r) => ({
              parsedPath: (0, import_path_to_regexp.parse)(path + r.path),
              verb: r.httpDecorator,
              path: r.path
            }))
          };
        })
      }
    };
  }).reduce((acc, m) => __spreadValues(__spreadValues({}, acc), m), {});
  return routemap;
};
var asOpenAPIPath = (parsedPath) => {
  return parsedPath.map((part) => import_lodash.default.isString(part) ? part : `/{${part.name}}`).join("");
};
var asOpenAPIPathParams = (parsedPath) => {
  return parsedPath.filter((part) => !import_lodash.default.isString(part)).map(({ name }) => ({
    name,
    schema: { type: "string" },
    required: true,
    in: "path"
  }));
};
var routemapToOpenAPI = (routemap, url = "http://localhost:5150") => {
  const builder = import_openapi3_ts.OpenApiBuilder.create({
    openapi: "3.0.0",
    servers: [{ url }],
    info: {
      title: "",
      version: ""
    },
    paths: {}
  });
  import_lodash.default.forEach(routemap, (controller, _name) => {
    controller.actions.forEach((action) => {
      action.routes.forEach((route) => {
        var _a;
        const path = asOpenAPIPath(route.parsedPath);
        const pathmap = builder.rootDoc.paths[path] || {};
        builder.addPath(path, __spreadValues(__spreadValues({}, pathmap), {
          [route.verb.toString()]: __spreadProps(__spreadValues({
            responses: {
              "200": {
                description: "OK"
              }
            }
          }, ((_a = action.schema) == null ? void 0 : _a.zod) && {
            requestBody: {
              required: true,
              content: {
                "application/json": {
                  schema: (0, import_zod_openapi.generateSchema)(action.schema.zod)
                }
              }
            }
          }), {
            parameters: asOpenAPIPathParams(route.parsedPath)
          })
        }));
      });
    });
  });
  return builder;
};
var getRouteSnippets = (routemap, verb, path, snippets = ["shell_curl"], url = "http://localhost:5150") => {
  const api = routemapToOpenAPI(routemap, url);
  const results = import_openapi_snippet.default.getEndpointSnippets(api.rootDoc, path, verb, snippets, {
    short: true
  });
  return results;
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  asOpenAPIPath,
  asOpenAPIPathParams,
  getRouteMap,
  getRouteSnippets,
  routemapToOpenAPI
});
