import { Request as Request$1 } from 'express';
export { NextFunction, Response } from 'express';

interface Request extends Request$1 {
    id: any;
    user?: any;
    state?: any;
    logger?: any;
}

interface RequestIdOpts {
    mode: 'none' | 'passthrough' | 'passthrough-or-generate' | 'generate';
}
interface ServerOptions {
    logging?: {
        logger?: boolean | any;
        middleware?: boolean | any;
    };
    staticFolder?: string;
    indexCatchAll?: boolean;
    forceHttps?: boolean;
    cookieSecret?: string;
    sendValidationErrors?: boolean;
    gzip?: boolean | any;
    helmet?: boolean | any;
    json?: boolean | any;
    requestId?: boolean | RequestIdOpts;
    urlencoded?: boolean | any;
    beforeControllers?: any;
    afterControllers?: any;
    beforeMiddleware?: any;
    afterMiddleware?: any;
}
interface CreateServerOptions {
    controllers: any[];
    opts?: ServerOptions;
}

export { CreateServerOptions, Request, RequestIdOpts, ServerOptions };
